import java.net.*;

public class Server {
	MulticastSocket ms;
	DatagramPacket bufdg;
	byte[] buf;
	
	final static int BOOL = 1, INT = 2, STRING = 3, STRUCT = 4, ENDSTRUCT = 5;
	
	int readStruct(int offset, int sp) {
		int offsetorig = offset;
	
		for (int i=0; i<sp; i++)
			System.out.print(" ");
			
		System.out.println("struct {");

		while (buf[offset]!=ENDSTRUCT)
			switch (buf[offset]) {
				case BOOL:
					readBool(offset+1, sp+1);
					offset+=2;
					break;
				case INT:
					readInt(offset+1, sp+1);
					offset+=5;
					break;
				case STRING:
					readString(offset+1, sp+1);
					offset+=buf[offset+1]+2;
					break;
				case STRUCT:
					offset += readStruct(offset+1, sp+1);
			}
			
		for (int i=0; i<sp; i++)
			System.out.print(" ");
			
		System.out.println("}");
		
		return offset - offsetorig + 2;
	}
	
	void readBool(int offset, int sp) {
		for (int i=0; i<sp; i++)
			System.out.print(" ");
			
		if (buf[offset]==0)
			System.out.println("bool: false");
		else
			System.out.println("bool: true");
	}
	
	void readInt(int offset, int sp) {
		int integer = ((int)buf[offset]) << 24;
		
		for (int k=1; k<4; k++)
			integer |= (int)(buf[offset+k]>=0 ? buf[offset+k] : 256+buf[offset+k]) << (8*(3-k));
			
		for (int i=0; i<sp; i++)
			System.out.print(" ");
			
		System.out.println("int: "+integer);
	}
	
	void readString(int offset, int sp) {
		for (int i=0; i<sp; i++)
			System.out.print(" ");
			
		try {
			System.out.print("string: " + new String(buf, offset+1, buf[offset], "US-ASCII"));
		} catch (Exception ex) { }
	}
	
	Server(String[] args) {
		buf = new byte[256];
		bufdg = new DatagramPacket(buf, buf.length);
		int i;
	
		try {
			ms = new MulticastSocket(Integer.parseInt(args[0]));
		} catch (Exception ex) {
			System.err.println(ex);
			System.exit(1);
		}
		
		for (i=1; i<args.length; i++)
			try {
				ms.joinGroup(InetAddress.getByName(args[i]));
			} catch (Exception ex) {
				System.err.println(ex);
			}
			
		for(;;) {
			try {
				ms.receive(bufdg);
			} catch (Exception ex) {
				System.err.println(ex);
				continue;
			}
			
			switch (buf[0]) {
				case BOOL:
					readBool(1, 0);
					System.out.println("");
					break;
				case INT:
					readInt(1, 0);
					System.out.println("");
					break;
				case STRING:
					readString(1, 0);
					System.out.println("");
					break;
				case STRUCT:
					readStruct(1, 0);
					System.out.println("");
			}
		}
	}
	
	public static void main(String[] args) {
		new Server(args);
	}
}
