import java.net.*;
import java.io.*;
import java.util.*;

class OutThread extends Thread {
	Socket s;
	byte[] buf;
	Vector[] odbiorcy;
	int typ, ile;
	
	OutThread(Socket s, byte[] buf, int ile, Vector[] odbiorcy, int typ) {
		this.s = s;
		this.buf = (byte[])buf.clone();
		this.odbiorcy = odbiorcy;
		this.ile = ile;
		this.typ = typ;
	}
	
	public void run() {
		byte[] tmp = new byte[1];
		tmp[0] = (byte)ile;
		try {
			s.getOutputStream().write(tmp, 0, 1);
			s.getOutputStream().write(buf, 0, ile);
		} catch (IOException ex) {
			try {
				s.close();
			} catch (Exception e) { }
			
			synchronized (odbiorcy[typ]) {
				odbiorcy[typ].remove(s);
			}
		}
	}
}

class InThread extends Thread {
	Socket s;
	Server server;
	InputStream in;
	byte[] buf = new byte[256];
	int typ;

	InThread(Socket s, Server server, int typ) {
		this.s = s;
		this.server = server;
		this.typ = typ;
		try {
			in = s.getInputStream();
		} catch (Exception ex) { }
	}
	
	public void run() {
		int len;
		try {
			len = in.read();
	
			while(in.available()<len);
		
			in.read(buf, 0, len);
		} catch (Exception ex) {
			System.err.println(ex);
			return;
		}
		
		server.powiadom(typ, buf, len);
	}
}

public class Server {
	ServerSocket ms;
	Vector[] odbiorcy = new Vector[6];
	
	public void powiadom(int typ, byte[] dane, int ile) {
		synchronized (odbiorcy[typ]) {
			Enumeration en = odbiorcy[typ].elements();
			while(en.hasMoreElements()) {
				Socket s = (Socket)en.nextElement();
				(new OutThread(s, dane, ile, odbiorcy, typ)).start();
			}
		}
	}
	
	Server(String[] args) {
		int i;
		
		for (i=0; i<6; i++)
			odbiorcy[i] = new Vector();
	
		try {
			ms = new ServerSocket();
			ms.setReuseAddress(true);
			ms.bind(new InetSocketAddress(Integer.parseInt(args[0])));
		} catch (Exception ex) {
			System.err.println(ex);
			System.exit(1);
		}

		for(;;) {
			int typ;
			Socket s;
			
			try {
				s = ms.accept();
				typ = s.getInputStream().read();
			} catch (Exception ex) {
				System.err.println(ex);
				continue;
			}
			
			if (typ<6 && typ>=0) {// nadawca wiadomosci rodzaju A-F
				InThread watek = new InThread(s, this, typ);
				watek.start();
			} else if (typ>=6 && typ<12)
				synchronized (odbiorcy[typ-6]) {
					odbiorcy[typ-6].add(s);
				}
		}
	}
	
	public static void main(String[] args) {
		new Server(args);
	}
}
