#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <stdio.h>
#include <netdb.h>
#include <string.h>
#include <strings.h>

#define BOOL 1
#define INT 2
#define STRING 3
#define STRUCT 4
#define ENDSTRUCT 5

char buf[256];

void readBool(int offset, int sp) {
	int i;

	for (i=0; i<sp; i++)
		printf(" ");
		
	if (buf[offset]==0)
		printf("bool: false\n");
	else
		printf("bool: true\n");
}

void readInt(int offset, int sp) {
	int i;

	for (i=0; i<sp; i++)
		printf(" ");
	
	memcpy(&i, &buf[offset], 4);
	printf("int: %d\n", ntohl(i));
}

void readString(int offset, int sp) {
	char tmp[256];
	int i;

	for (i=0; i<sp; i++)
		printf(" ");	

	memcpy(tmp, &buf[offset+1], buf[offset]);
	tmp[buf[offset]]=0;
		
	printf("string: %s", tmp);
}

int readStruct(int offset, int sp) {
	int offsetorig = offset;
	int i;

	for (i=0; i<sp; i++)
		printf(" ");
		
	printf("struct {\n");

	while (buf[offset]!=ENDSTRUCT)
		switch (buf[offset]) {
			case BOOL:
				readBool(offset+1, sp+1);
				offset+=2;
				break;
			case INT:
				readInt(offset+1, sp+1);
				offset+=5;
				break;
			case STRING:
				readString(offset+1, sp+1);
				offset+=buf[offset+1]+2;
				break;
			case STRUCT:
				offset += readStruct(offset+1, sp+1);
		}
		
	for (i=0; i<sp; i++)
		printf(" ");

	printf("}\n");
	
	return offset - offsetorig + 2;
}

int readall(int s, char *buf, int len) {
	int cnt = 0;

	while (cnt!=len) {
		if (recv(s, &buf[cnt], 1, 0)==-1)
			return -1;
		cnt++;
	}
	
	return 0;
}

int main(int argc, char** argv) {
	int sd = socket(AF_INET, SOCK_STREAM, 0);
	struct sockaddr_in adr;
	struct hostent* h;
	char data[256], tmp;
	
	if (argc<4) {
		fprintf(stderr, "Argumenty: port host typ\nTypy:\nA - bool\nB - int\nC - string\nD - struct { int; bool; string; }\nE - struct { struct { int; bool; }; string; }\nF - struct { int; int; int; }\n");
		return EXIT_FAILURE;
	}
	
	if (argv[3][0]<'A' || argv[3][0]>'F') {
		fprintf(stderr, "Nieznany typ\n");
		return EXIT_FAILURE;
	}
	
	if (!(h = gethostbyname(argv[2]))) {
		perror("gethostbyname");
		return EXIT_FAILURE;
	}
	
	bzero(&adr, sizeof(struct sockaddr_in));
	adr.sin_family = AF_INET;
	adr.sin_port = htons(atoi(argv[1]));
	memcpy((char *)&adr.sin_addr.s_addr, h->h_addr, h->h_length);
	
	if (connect(sd, (struct sockaddr*)&adr, sizeof(struct sockaddr_in))) {
		perror("connect");
		return EXIT_FAILURE;
	}
	
	tmp = argv[3][0] - 'A' + 6;
	
	send(sd, &tmp, 1, 0);

	for (;;) {
		if (recv(sd, &tmp, 1, 0)<=0 || readall(sd, buf, tmp)==-1) {
			fprintf(stderr, "Serwer zamknal polaczenie\n");
			return EXIT_FAILURE;
		}
		
		switch (buf[0]) {
			case BOOL:
				readBool(1, 0);
				printf("\n");
				break;
			case INT:
				readInt(1, 0);
				printf("\n");
				break;
			case STRING:
				readString(1, 0);
				printf("\n");
				break;
			case STRUCT:
				readStruct(1, 0);
				printf("\n");
		}
	}
	
	return EXIT_SUCCESS;
}
