#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <stdio.h>
#include <netdb.h>
#include <string.h>
#include <strings.h>

const int BOOL = 1, INT = 2, STRING = 3, STRUCT = 4, ENDSTRUCT = 5;

char buf[256];

int writeall(int s, void *buf, int len) {
	int total = 0;
	int bytesleft = len;
	int n;

	while(total < len) {
		n = send(s, buf+total, bytesleft, 0);
		if (n == -1)
			break;
		total += n;
		bytesleft -= n;
	}

	return n==-1?-1:0;
}

int getbool() {
	int c = 0;
	fgets(buf, 256, stdin);
	sscanf(buf, "%d", &c);
	return c==1;
}

int getint() {
	int i = 0;
	fgets(buf, 256, stdin);
	sscanf(buf, "%d", &i);
	return i;
}

void getstring() {
	fgets(buf, 256, stdin);
}

int main(int argc, char** argv) {
	int sd = socket(AF_INET, SOCK_STREAM, 0);
	struct sockaddr_in adr;
	struct hostent* h;
	char data[256], tmp;
	int ile;
	
	if (argc<4) {
		fprintf(stderr, "Argumenty: port host typ\nTypy:\nA - bool\nB - int\nC - string\nD - struct { int; bool; string; }\nE - struct { struct { int; bool; }; string; }\nF - struct { int; int; int; }\n");
		return EXIT_FAILURE;
	}
	
	if (argv[3][0]<'A' || argv[3][0]>'F') {
		fprintf(stderr, "Nieznany typ\n");
		return EXIT_FAILURE;
	}
	
	if (!(h = gethostbyname(argv[2]))) {
		perror("gethostbyname");
		return EXIT_FAILURE;
	}
	
	bzero(&adr, sizeof(struct sockaddr_in));
	adr.sin_family = AF_INET;
	adr.sin_port = htons(atoi(argv[1]));
	memcpy((char *)&adr.sin_addr.s_addr, h->h_addr, h->h_length);
	
	if (connect(sd, (struct sockaddr*)&adr, sizeof(struct sockaddr_in))) {
		perror("connect");
		return EXIT_FAILURE;
	}
	
	switch (argv[3][0]) {
		case 'A':
			printf("bool: ");
			data[0] = BOOL;
			data[1] = getbool();
			ile = 2;
			break;
		case 'B':
			printf("int: ");
			data[0] = INT;
			ile = htonl(getint());
			memcpy(&data[1], &ile, 4);
			ile = 5;
			break;
		case 'C':
			printf("string: ");
			data[0] = STRING;
			getstring();
			data[1] = strlen(buf);
			strcpy(&data[2], buf);
			ile = data[1] + 2;
			break;
		case 'D':
			printf("struct {\n int: ");
			data[0] = STRUCT;
			data[1] = INT;
			ile = htonl(getint());
			memcpy(&data[2], &ile, 4);
			printf(" bool: ");
			data[6] = BOOL;
			data[7] = getbool();
			printf(" string: ");
			getstring();
			data[8] = STRING;
			data[9] = strlen(buf);
			strcpy(&data[10], buf);
			data[10+strlen(buf)] = ENDSTRUCT;
			printf("}\n");
			ile = 11 + strlen(buf);
			break;
		case 'E':
			printf("struct {\n struct {\n  int: ");
			data[0] = STRUCT;
			data[1] = STRUCT;
			data[2] = INT;
			ile = htonl(getint());
			memcpy(&data[3], &ile, 4);
			printf("  bool: ");
			data[7] = BOOL;
			data[8] = getbool();
			data[9] = ENDSTRUCT;
			printf(" }\n string: ");
			getstring();
			data[10] = STRING;
			data[11] = strlen(buf);
			strcpy(&data[12], buf);
			data[12+strlen(buf)] = ENDSTRUCT;
			printf("}\n");
			ile = 13 + strlen(buf);
			break;
		case 'F':
			printf("struct {\n int: ");
			data[0] = STRUCT;
			data[1] = INT;
			ile = htonl(getint());
			memcpy(&data[2], &ile, 4);
			printf(" int: ");
			data[6] = INT;
			ile = htonl(getint());
			memcpy(&data[7], &ile, 4);
			printf(" int: ");
			data[11] = INT;
			ile = htonl(getint());
			memcpy(&data[12], &ile, 4);
			data[16] = ENDSTRUCT;
			ile = 17;
			printf("}\n");
	}
	
	tmp = argv[3][0] - 'A';
	
	writeall(sd, &tmp, 1);
	
	tmp = ile;
	
	writeall(sd, &tmp, 1);
	
	if (writeall(sd, data, ile)==-1) {
		perror("sendto");
		return EXIT_FAILURE;
	}
	
	return EXIT_SUCCESS;
}
