/**
 * Copyright (c) 2001/2003 Distributed Systems Research Group.
 * All rights reserved.
 *
 * For more information on Distributed Systems Research Group (DSRG),
 * please see <http://www.ics.agh.edu.pl/>.
 *
 * @author radzisz
 * file name: NoteBoard.java
 *
 */

package edu.agh.sr.madej;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Interfejs obiektu zdalnego reprezentujacego tablice.
 */
public interface NoteBoard extends Remote {

	/**
 	 * Dodaje linijke tekstu do tablicy.
 	 *
 	 * @param text tekst do dodania
 	 */
	public void appendText(String text) throws RemoteException;
	
	/**
 	 * Czysci tablice.
 	 */
	public void clean() throws RemoteException;

	/**
 	 * Zwraca zawartosc tablicy.
 	 */
	public String getText() throws RemoteException;
}
