/**
 * Copyright (c) 2001/2003 Distributed Systems Research Group.
 * All rights reserved.
 *
 * For more information on Distributed Systems Research Group (DSRG),
 * please see <http://www.ics.agh.edu.pl/>.
 *
 * @author radzisz
 * file name: UserImpl.java
 *
 */
package edu.agh.sr.madej;

import java.io.Serializable;

/**
 * Klasa reprezentujaca informacje o kliencie.
 */
public class UserImpl implements User, Serializable {
	private String name;
	private String lastName;
	private String nick;

	/**
	 * Konstruktor.
	 *
	 * @param nick nick
	 * @param name nazwisko
	 * @param lastName imie
	 */
	public UserImpl(String nick, String name, String lastName) {
		this.nick = nick;
		this.lastName = lastName;
		this.name = name;
	}
	
	/**
	 * Zwraca nazwisko skojarzone z danym klientem.
	 */
	public String getLastName() {
		return lastName;
	}
	
	/**
	 * Zwraca imie skojarzone z danym klientem.
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * Zwraca nick skojarzony z danym klientem.
	 */
	public String getNick() {
		return nick;
	}
}
