package edu.agh.sr.madej;

import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.MarshalledObject;
import java.rmi.Naming;
import java.rmi.activation.*;
import java.util.*;

/**
 * Klasa reprezentujaca serwer.
 */
public class NoteBoardServer {

	/**
	 * Statyczna metoda umozliwiajaca uruchomienie serwera.
	 *
	 * @param args tablica parametrow
	 */
	public static void main(String[] args) {
		int regport = Integer.parseInt(args[0]);
		String location = "";
		
		try {
			System.setSecurityManager(new SecurityManager());
			
			ActivationGroupDesc.CommandEnvironment ace = null;
			
			Properties props = System.getProperties();
			
			ActivationGroupDesc exampleGroup = new ActivationGroupDesc(props, ace);
			
			// Rejestrujemy utworzone srodowisko
			ActivationGroupID agi = ActivationGroup.getSystem().registerGroup(exampleGroup);
			//ActivationGroupID agi = system.registerGroup(exampleGroup);
			
			MarshalledObject data = null;
			ActivationDesc desc = new ActivationDesc(agi, "edu.agh.sr.madej.NoteBoardImpl", location, data);
			
			NoteBoard nb = (NoteBoard)Activatable.register(desc);
	
			// Efekt rejestracji ?aktywujacy? stub
			Registry reg = LocateRegistry.getRegistry("localhost", regport);
			reg.rebind("madej", nb);
			
			System.out.println("Exported NoteBoard");
			System.exit(0);
		} catch (Exception e) {
			log("Could not externalize noteboard - cannot continue");
			log(e.toString());
		}
	}

	/**
	 * Metoda logujaca
	 *
	 * @param msg tekst do zalogowania
	 */
	public static void log(String msg) {
		System.out.println(msg);
	}

	/**
	 * Wypisuje sposob uzycia programu
	 */
	private static void usage() {
		System.out.println("Usage: program <rmiregistry port>");
	}
}
