package sr.madej.sender;

import org.omg.CORBA.ORB;
import org.omg.CosNaming.*;
import sr.madej.generated.*;

public class Sender {
	public static void main(String[] args) {
		if (args.length < 2) {
			System.out.println("parameters: DEBUG|WARNING|PANIC interval");
			System.exit(0);
		}

		int id = (int)(Math.random() * 4096);
		
		int level;
		
		if (args[0].equals("DEBUG"))
			level = 0;
		else if (args[0].equals("WARNING"))
			level = 1;
		else
			level = 2;
			
		int period = Integer.parseInt(args[1]);
		
		ORB orb = ORB.init(args, null);
		
		try {
			
			org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
			
			NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);
			Logger logger = LoggerHelper.narrow(ncRef.resolve_str("madej"));
	
			System.out.println("sender started, id = " + id);
			
			for (;;) {
				logger.log(new LogRecordHolder(new LogRecord(LogPriority.from_int(level), (new java.util.Date()).getTime(), "messgae from sender id " + id)));
				Thread.sleep(1000*period);	
			}
		} catch (Exception ex) {
			System.err.println(ex);
		}
	}
}
